import os

def getlist(dir, recursive, filetype, exclude):

	filepath = []
		
	# recursive = True
	if recursive:

		# filetype assigned
		if filetype and isinstance(filetype, (list, tuple)):

			for root, directories, files in os.walk (dir, followlinks=False):
				for file in files:
					
					if exclude:
						if not file.lower().endswith(filetype):
							fname = os.path.join(root,file)
							if os.path.isfile(fname):
								filepath.append(fname)
					else:
						if file.lower().endswith(filetype):
							fname = os.path.join(root,file)
							if os.path.isfile(fname):
								filepath.append(fname)


		# all files
		else:
			for root, directories, files in os.walk (dir, followlinks=False):
				for file in files:
					fname = os.path.join(root,file)
					if os.path.isfile(fname):
						filepath.append(fname)

	# recursive = False
	else:
		# filetype assigned
		if filetype and isinstance(filetype, (list, tuple)):
			
			for file in os.listdir(dir):
				
				if exclude:
					if not file.lower().endswith(filetype):
						fname = os.path.join(dir,file)
						if os.path.isfile(fname):
							filepath.append(fname)
				else:
					if file.lower().endswith(filetype):
						fname = os.path.join(dir,file)
						if os.path.isfile(fname):
							filepath.append(fname)

		# all files
		else:
			for file in os.listdir(dir):
				fname = os.path.join(dir,file)
				if os.path.isfile(fname):
					filepath.append(fname)

	return filepath
