import pefile
import hashlib

def md5(file):
	try:
		fh = open(file, 'rb')
		m = hashlib.md5()

		while True:
			data = fh.read(8192)
			if not data:
				break

			m.update(data)

		return m.hexdigest()
	except:
		pass

def sha1(file):
	try:
		fh = open(file, 'rb')
		s = hashlib.sha1()
		
		while True:
			data = fh.read(8192)
			if not data:
				break

			s.update(data)

		return s.hexdigest()

	except:
		pass

def sha256(file):
	try:
		fh = open(file, 'rb')
		s = hashlib.sha256()
		
		while True:
			data = fh.read(8192)
			if not data:
				break

			s.update(data)

		return s.hexdigest()

	except:
		pass

def imphash(file):
	try:
		pe = pefile.PE(file)
		return pe.get_imphash()
	except:
		pass

def all_hashes(file):
	# experimental
	# reserved for future use
	try:
		fh = open(file, 'rb')
		m = hashlib.md5()
		s = hashlib.sha1()
		s256 = hashlib.sha256()
		
		while True:
			data = fh.read(8192)
			if not data:
				break

			m.update(data)
			s.update(data)
			s256.update(data)

		md5  = m.hexdigest()
		sha1 = s.hexdigest()
		sha256 = s256.hexdigest()

		return md5, sha1, sha256

	except:
		pass
